pause on

****************************************************
* Sample Selection
****************************************************

keep if (RelToHD==10)                          /* keep heads only; code is 10 for all years 1985-2009 (it was 1 in some earlier years) */

keep if (SRC==1)                              /* keep SRC sample only */

keep if (year>=1987)                      

keep if (Age>=25 & Age<=60)

replace Age = Age-25+1                    /* normalize age */


****************************************************
* For Family Income
****************************************************

preserve

  pause This is the sample that will be saved as FamilyIncome_PSID

  keep pid year Age maleHD marriedHD NumberInFU FamInc

  saveold "G:\labinc\PSID_data_NEW\FamilyIncome_PSID.dta", replace 

restore



****************************************************
* For Male Earnings
****************************************************

preserve

  keep if (maleHD==1)

  keep if (SelfEmpHD==1 | SelfEmpHD==2)         /* allow both categories for now */

  pause This is the sample that will be saved as MaleEarnings_PSID

  keep pid year Age LabIncHD Wages2HD 

  saveold "G:\labinc\PSID_data_NEW\MaleEarnings_PSID.dta", replace 

  pause

restore


